import { spread, mergeProps as mergeProps$1, template } from 'solid-js/web';
import HighlightJS from 'highlight.js';
import { mergeProps, splitProps, createMemo } from 'solid-js';

// src/index.tsx

// src/utils/index.ts
function escapeHtml(value) {
  return value.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;").replace(/'/g, "&#x27;");
}

// src/index.tsx
var _tmpl$ = /* @__PURE__ */ template(`<pre><code>`);
var Highlight = (_props) => {
  const props = mergeProps({
    autoDetect: true,
    ignoreIllegals: true,
    language: ""
  }, _props);
  const [, rest] = splitProps(props, ["language", "autoDetect", "ignoreIllegals", "children", "class", "innerHTML"]);
  const cannotDetectLanguage = !props.autoDetect && !props.language && props.children && !HighlightJS.getLanguage(props.children.toString());
  const className = cannotDetectLanguage ? "" : `hljs ${props.language}`;
  const getHighlightedCode = createMemo(() => {
    const childrenString = props.children?.toString();
    if (!childrenString) {
      return "";
    }
    if (cannotDetectLanguage) {
      return escapeHtml(childrenString);
    }
    if (props.autoDetect) {
      const result = HighlightJS.highlightAuto(childrenString);
      return result.value;
    } else {
      const result = HighlightJS.highlight(childrenString, {
        language: props.language,
        ignoreIllegals: props.ignoreIllegals
      });
      return result.value;
    }
  });
  return (() => {
    var _el$ = _tmpl$(), _el$2 = _el$.firstChild;
    spread(_el$2, mergeProps$1({
      get ["class"]() {
        return `${className} ${props.class || ""}`;
      },
      get innerHTML() {
        return getHighlightedCode();
      }
    }, rest), false, false);
    return _el$;
  })();
};

export { Highlight };
